(*  Title:      RqandIds.thy
    Author:     Ludovic Henrio 
                2008

    Note:       
*)

header {*lemmas on Requests and Ids: On fetching for Rqs and Ids  (lemmas on CorrectComponents moved to CorrectComponent.thy)*}

theory RqAndIds imports GCM  CorrectComponent CpList
begin


declare cpSetcomposite[simp del]
declare cpSetcomposite_set[simp]

(* SubComponent_SmallerRqIdList *)
lemma SubComponent_SmallerRqIdList[rule_format]: " \<forall> C\<in>cpSet C'. set (RqIdList C) \<subseteq> set (RqIdList C')";
apply (rule induct_Comp);
apply simp+; 
apply auto;
apply (drule_tac x=C' in bspec);
apply simp;
(*1*)
apply (drule_tac x=C in bspec);
apply auto;
apply (subgoal_tac "set (RqIdList C')\<subseteq>set (RqIdListList cplist)")
apply auto;
apply (subgoal_tac " \<forall> C'\<in>set cplist. set (RqIdList C')\<subseteq>set (RqIdListList cplist)");
apply force;
apply (induct_tac cplist);
apply auto;
done;

lemma RequestOfSubComponent_inRqIdList_unique_induct[rule_format]: "(\<forall> i n . (i<(length (cpList C))\<and>n<length (getQueue (cpList C!i)))\<longrightarrow> (\<exists> m. id ((getQueue (cpList C!i))!n) = (RqIdList C)!m\<and>m<length (RqIdList C))) \<and>
(\<forall> i' n'.(i'<length (cpListlist CL)\<and>n'<length (getQueue ((cpListlist CL)!i')))\<longrightarrow> (\<exists> m. id ((getQueue (cpListlist CL!i'))!n') = (RqIdListList CL)!m\<and>m<length (RqIdListList CL)) )"
apply (induct_tac C and CL);
apply (clarify);
apply simp;
apply (rule_tac x="length (map fid (PcomputedResults PrimState_ext_type))+(length (PcurrentReqs (PintState PrimState_ext_type))+n)" in exI)
apply (simp only: nth_append_length_plus);
apply force;
apply clarify;
apply simp+;
apply (case_tac i);
apply simp+;
apply (rule_tac x="length (map fid (CcomputedResults CompState_ext_type))+n" in exI); 
apply (simp only: nth_append)+;
apply force;
apply (case_tac list);
(*4*)
apply force;
apply simp+;
apply (drule_tac x=nat in spec)
apply (drule_tac x=n in spec)
apply (erule impE);
apply force;
apply (erule exE);
apply (rule_tac x="length (map fid (CcomputedResults CompState_ext_type))+(length (map Request.id (Cqueue CompState_ext_type))+m)" in exI); 
apply (simp only: nth_append)+;
apply force;
apply force;
apply auto;
(*1*)
apply (case_tac "i'<length(cpList Component)")
apply (drule_tac x=i' in spec)
apply (rotate_tac -1);
apply (drule_tac x=n' in spec)
apply (erule impE);
apply (simp only: nth_append)+;
apply force;
apply (erule exE);
apply (simp add: nth_append)+;
apply (rule_tac x=m in exI); 
apply force;
(*1*)
apply (rotate_tac 1);
apply (drule_tac x="i'-length (cpList Component)" in spec)
apply (rotate_tac -1);
apply (drule_tac x=n' in spec)
apply (simp only: nth_append)+;
apply auto;
done

(* RequestOfSubComponent_inRqIdList_unique *)

lemma RequestOfSubComponent_inRqIdList_unique: "\<lbrakk>i<length (cpList C);n<length (getQueue (cpList C!i));CorrectComponent C\<rbrakk>\<Longrightarrow> \<exists>! m.( id ((getQueue (cpList C!i))!n) = (RqIdList C)!m\<and>m<length (RqIdList C))"
apply auto;
defer;
apply (unfold CorrectComponent_def);
apply clarify;
apply (simp only: List.distinct_conv_nth)
apply simp;
apply (drule_tac x=y in spec)
apply force;
apply (insert RequestOfSubComponent_inRqIdList_unique_induct [of C "[]"]);
apply force;
done;

(* RequestOfSubComponent_inRqIdList *)
lemma RequestOfSubComponent_inRqIdList: "\<lbrakk>C'\<in>cpSet C; Q\<in>set (getQueue C');CorrectComponent C\<rbrakk>\<Longrightarrow> id Q \<in> set (RqIdList C)"
apply ((simp add: cpSetAndList in_set_conv_nth)+,(erule exE)+);
apply (insert RequestOfSubComponent_inRqIdList_unique);
apply (drule_tac x=i in meta_spec);
apply (drule_tac x=C in meta_spec);
apply (drule_tac x=ia in meta_spec);
apply auto; 
done;


(* ResultOfSubComponent_inComputedResultList_induct *)
lemma ResultOfSubComponent_inComputedResultList_induct: " \<forall> n. (C'\<in>cpSet C\<and>n<length (getComputedResults (C')))\<longrightarrow> 
            (\<exists> m . m<(length (RqIdList C))\<and> fid ((getComputedResults (C'))!n) = ((RqIdList C)!m))"
apply (rule induct_Comp);
apply auto;
apply (rule_tac x=n in exI);
apply (force simp: nth_append);
apply (simp add: nth_append);
apply (rule_tac x=n in exI);
apply force;
apply (drule_tac x=C'a in bspec);
apply auto;
(*1*)
apply (drule_tac x=n in spec);
apply simp;
apply clarify;
apply (simp add: cpSet_def set_conv_nth)
apply auto;
apply (rule_tac x="length  (CcomputedResults s) + length (Cqueue s) 
                   +length  (RqIdListList (take i (cplist)))+m" in exI);
apply auto;
apply (simp add: lengthlistlist lengthlistlist_Id);
(*2*)
apply (subgoal_tac  " listsum (map length (take i (map RqIdList  cplist))) + m
          < listsum (map length (map RqIdList cplist))")
apply (force simp: take_map);
apply (rule listtake_length);
apply simp+;
apply (simp add: nth_append);
apply (subgoal_tac " \<forall> ib m. (ib < length cplist\<and>m<length (RqIdList (cplist ! ib))) \<longrightarrow> 
             RqIdList (cplist ! ib) ! m = RqIdListList cplist ! (length (RqIdListList (take ib cplist))+m)")
apply simp;
(*1*)
apply (induct_tac cplist)
apply force;
apply clarify;
apply (case_tac ib)
apply (force simp: nth_append)+;
done;

(* RequestOfSubComponent_inComputedResultList_unique *)
lemma RequestOfSubComponent_inComputedResultList_unique: "\<lbrakk>C'\<in>cpSet C;n<length (getComputedResults C');CorrectComponent C\<rbrakk>\<Longrightarrow> 
            (\<exists>! m . m<(length (RqIdList C))\<and> fid ((getComputedResults C')!n) = ((RqIdList C)!m))"
apply (insert ResultOfSubComponent_inComputedResultList_induct, auto)
apply (unfold CorrectComponent_def);
apply clarify;
apply (simp only: List.distinct_conv_nth)
apply simp;
apply (drule_tac x=y in spec)
apply (rotate_tac -1);
apply (drule_tac x=m in spec)
apply force;
done;

(* ResultOfSubComponent_inRqIdList *)
lemma  ResultOfSubComponent_inRqIdList: "\<lbrakk>C'\<in> cpSet C;R\<in> set (getComputedResults C');CorrectComponent C\<rbrakk>\<Longrightarrow> 
             fid R \<in> set (RqIdList C)"
apply (insert RequestOfSubComponent_inComputedResultList_unique);
apply (drule_tac x=C' in meta_spec);
apply (drule_tac x=C in meta_spec);
apply (simp add: set_conv_nth)
apply clarify;
apply (drule_tac x=i in meta_spec);
apply auto; 
done;

(*CurrentRequestOfSubcomponent_inRqIdList_induct*)
lemma CurrentRequestOfSubcomponent_inRqIdList_induct[rule_format]: " \<forall> N itfs s.((Primitive N itfs s)\<in>cpSet C
               \<and>(f\<in> set (PcurrentReqs (PintState s))))\<longrightarrow> (\<exists> m . m<(length (RqIdList C))\<and> ((RqIdList C)!m)=f)"
apply (rule induct_Comp);
apply auto;
apply (simp add: set_conv_nth, erule exE);
apply (rule_tac x="length (PcomputedResults s) + i" in exI);
apply (force simp: nth_append);
apply (drule_tac x=C' in bspec);
apply assumption;
(*1*)
apply (erule impE)
apply force;
apply (simp add: set_conv_nth);
apply clarify;
apply (rule_tac x="length  (CcomputedResults s) + length (Cqueue s) 
                   +length  (RqIdListList (take ia (cplist)))+m" in exI);
apply auto;
(*2*)
apply (simp add: lengthlistlist lengthlistlist_Id);
apply (subgoal_tac  " listsum (map length (take ia (map RqIdList  cplist))) + m
          < listsum (map length (map RqIdList cplist))")
apply (force simp: take_map);
apply (rule listtake_length);
apply simp+;
apply (simp add: nth_append);
apply (subgoal_tac " \<forall> ib m. (ib < length cplist\<and>m<length (RqIdList (cplist ! ib))) \<longrightarrow> 
             RqIdList (cplist ! ib) ! m = RqIdListList cplist ! (length (RqIdListList (take ib cplist))+m)")
(*2*)
apply simp;
apply (induct_tac cplist)
apply force;
apply clarify;
apply (case_tac ib)
apply (force simp: nth_append)+;
done;

(*CurrentRequestOfSubcomponent_inRqIdList_unique*)
lemma CurrentRequestOfSubcomponent_inRqIdList_unique: "\<lbrakk>CorrectComponent C;  (Primitive N itfs s)\<in>cpSet C ; 
               f\<in> set (PcurrentReqs (PintState s))\<rbrakk>\<Longrightarrow> (\<exists>! m . m < (length (RqIdList C)) \<and> (RqIdList C)!m=f)"
apply (insert CurrentRequestOfSubcomponent_inRqIdList_induct [of N itfs s C f], auto simp: set_conv_nth)
apply (unfold CorrectComponent_def);
apply clarify;
apply (simp only: List.distinct_conv_nth)
apply (drule_tac x=y in spec)
apply (rotate_tac -1);
apply (drule_tac x=ma in spec)
apply auto;
done;


lemma findInResultD: "(findInResultList (getComputedResults C) f)=Some v\<Longrightarrow>
                        \<exists>n<length (getComputedResults C). (getComputedResults C)!n=\<lparr>fid=f,fValue=v\<rparr>"
apply (induct "(getComputedResults C)");
apply auto;
apply (case_tac "(fid a)=f");
apply auto;
done;



(*RqIdInComponent_inRqIdListlistofCL_pre *)
lemma RqIdInComponent_inRqIdListlistofCL_pre[rule_format]: " \<forall> i k. ((i<length CL\<and>j<length (RqIdList (CL!i))
                    \<and>k=listsum (map length (take (i) (map RqIdList CL)))))\<longrightarrow>
             (((RqIdList (CL!i))!j=(RqIdListList CL)!(k+j))
\<and>(listsum (map length (take i (map RqIdList CL)))+j)<length (RqIdListList CL))"
apply (induct_tac CL);
apply auto;
apply (case_tac i);
apply simp+;
apply (simp add:  nth_append);
apply (drule_tac x=nat in spec)
apply simp+;
apply (case_tac nat);
apply ( simp add:  nth_append)+;
apply (case_tac i);
apply simp+;
done;
(* a request in rqidlist of a component of CL is inside the rqidlistlist of CL + gives the index*)

(*  RqIdInComponent_inRqIdListlistofCL*)
lemma  RqIdInComponent_inRqIdListlistofCL: "\<lbrakk> i<length CL;j<length (RqIdList (CL!i))\<rbrakk>\<Longrightarrow>
             (RqIdList (CL!i))!j=(RqIdListList CL)!(listsum (map length (take i (map RqIdList CL)))+j) 
\<and>(listsum (map length (take i (map RqIdList CL)))+j)<length (RqIdListList CL)"
by (auto simp:RqIdInComponent_inRqIdListlistofCL_pre);


(*RqIdList of 2 different components are disjoint *)
(*RqIdListofTwoComponents_disjoint*)
lemma RqIdListofTwoComponents_disjoint: "\<lbrakk> CorrectComponentWeak (Composite N  itfs cplist bindings s); i\<noteq>j ;i<length cplist; j<length cplist\<rbrakk>
                \<Longrightarrow> list_inter (RqIdList (cplist!i)) (RqIdList (cplist!j)) = []"
apply (unfold CorrectComponentWeak_def)
apply clarify;
apply (thin_tac "CorrectComponentStructure (Composite N itfs cplist bindings s)");
apply (thin_tac "distinct (map getName (cpList (Composite N itfs cplist bindings s)))");
apply (subgoal_tac "distinct ((RqIdList (cplist ! i))@(RqIdList (cplist ! j)))");
apply (insert list_inter_distinct);
apply (drule_tac x= "(RqIdList (cplist ! i))" in meta_spec);
apply (drule_tac x= "(RqIdList (cplist ! j))" in meta_spec);
apply force;
apply (thin_tac "\<And>L1 L2. (list_inter L1 L2 = [] \<and> distinct L1 \<and> distinct L2) = distinct (L1 @ L2)");
apply auto;
apply (simp add: List.distinct_conv_nth)
apply (rule allI,rule impI)+;
apply (rule impI)+;
apply (frule  RqIdInComponent_inRqIdListlistofCL)
apply simp+;
apply (frule_tac j=ja in  RqIdInComponent_inRqIdListlistofCL)
apply simp+;
apply (simp add: List.distinct_conv_nth)
apply (rule allI,rule impI)+;
apply (rule impI)+;
apply (rotate_tac 2)
apply (frule  RqIdInComponent_inRqIdListlistofCL)
apply simp+;
apply (frule_tac j=ja in  RqIdInComponent_inRqIdListlistofCL)
apply simp+;
apply (simp add: in_set_conv_nth);
apply (simp add: List.distinct_conv_nth)
apply auto;
apply (frule  RqIdInComponent_inRqIdListlistofCL);
apply simp;
apply (rotate_tac 2)
apply (frule  RqIdInComponent_inRqIdListlistofCL);
apply simp;
apply (rotate_tac 3);
apply clarify;
apply (drule_tac x="(listsum (map length (take i (map RqIdList cplist))) + ia)" in spec)
apply simp+;
apply (rotate_tac -1);
apply (drule_tac x="(listsum (map length (take j (map RqIdList cplist))) + iaa)" in spec)
apply (drule_tac L="(map RqIdList cplist)" and j=ia and k=iaa in listlistith);
apply simp+;
done;

(*RqIdList of  subcomponents disjoint from local list of composite*)
(*RqIdListofSubcomponentAndParent_disjoint*)
lemma RqIdListofSubcomponentAndParent_disjoint: "\<lbrakk> CorrectComponentWeak (Composite N  itfs cplist bindings s); i<length cplist\<rbrakk>
                \<Longrightarrow> list_inter (RqIdList (cplist!i)) (RqIdLocalList (Composite N  itfs cplist bindings s)) = []"
apply (unfold CorrectComponentWeak_def)
apply clarify;
apply (thin_tac "CorrectComponentStructure (Composite N itfs cplist bindings s)");
apply (thin_tac "distinct (map getName (cpList (Composite N itfs cplist bindings s)))");
apply (subgoal_tac "distinct ((RqIdList (cplist ! i))@(RqIdLocalList (Composite N  itfs cplist bindings s)))");
apply (insert list_inter_distinct);
apply (drule_tac x= "(RqIdList (cplist ! i))" in meta_spec);
apply (drule_tac x= "(RqIdLocalList (Composite N  itfs cplist bindings s))" in meta_spec);
apply force;
(*1*)
apply (thin_tac "\<And>L1 L2. (list_inter L1 L2 = [] \<and> distinct L1 \<and> distinct L2) = distinct (L1 @ L2)");
apply auto;
apply (simp add: List.distinct_conv_nth)
apply (rule allI,rule impI)+;
apply (rule impI)+;
apply (frule  RqIdInComponent_inRqIdListlistofCL)
apply simp+;
apply (frule_tac j=j in  RqIdInComponent_inRqIdListlistofCL)
apply simp+;
(*2*)
apply (subgoal_tac "(a,b)\<in> set (RqIdListList cplist)");
apply auto;
apply (force simp:  RqIdInComponent_inRqIdListlistofCL in_set_conv_nth);
(*1*)
apply (subgoal_tac "(a,b)\<in> set (RqIdListList cplist)");
apply auto;
apply (force simp:  RqIdInComponent_inRqIdListlistofCL in_set_conv_nth);
done;

(* SubComponentInclusionRule_pre*)
lemma SubComponentInclusionRule_pre: " \<forall> C1 C2. (C1\<in>cpSet C\<and> C2\<in>cpSet C\<and> C\<noteq>C1\<and>C\<noteq>C2\<and>C1\<noteq>C2 \<longrightarrow> ((C1\<in>cpSet C2)\<or>(C2\<in>cpSet C1)\<or>
(  \<exists> C'\<in>cpSet C. \<exists> N itfs cpList bindings s. 
                (C'=(Composite N  itfs cpList bindings s) \<and> (\<exists> D1\<in> set cpList. \<exists>D2\<in>set cpList. 
                      C1\<in>cpSet D1\<and>C2\<in>cpSet D2 \<and>D1\<noteq>D2)))))"
apply (rule_tac P="\<lambda>C.\<forall> C1 C2. (C1\<in>cpSet C\<and> C2\<in>cpSet C\<and> C\<noteq>C1\<and>C\<noteq>C2\<and>C1\<noteq>C2 \<longrightarrow> ((C1\<in>cpSet C2)\<or>(C2\<in>cpSet C1)\<or>
(  \<exists> C'\<in>cpSet C. \<exists> N itfs cpList bindings s. 
                (C'=(Composite N  itfs cpList bindings s) \<and> (\<exists> D1\<in> set cpList. \<exists>D2\<in>set cpList. 
                      C1\<in>cpSet D1\<and>C2\<in>cpSet D2 \<and>D1\<noteq>D2)))))" in induct_Comp);
apply simp+;
apply (rule allI)+;
apply (rule impI)+;
apply (erule conjE)+;
apply (erule disjE)+;
apply simp+;
apply (erule bexE)+;
apply (case_tac "C'=C'a");
apply simp+;
(*2*)
apply (case_tac "C'=C1")
apply simp+;
apply (case_tac "C'=C2")
apply simp+;
apply (drule_tac x=C' in bspec);
apply simp+;
(*2*)
apply (drule_tac x=C1 in spec);
apply (drule_tac x=C2 in spec);
apply simp+;
apply (erule disjE,rule disjI1);
apply force;
apply (erule disjE,rule disjI2,rule disjI1);
apply force;
apply (rule disjI2,rule disjI2);
apply (erule bexE,(erule exE)+,(erule conjE),(erule exE)+);
apply (erule bexE);
apply force;
(*1*)
apply (rule disjI2);
apply (rule disjI2);
apply (rule disjI1);
apply (rule_tac x=C'a in bexI);
apply simp+;
apply (rule_tac x=C' in bexI);
apply simp+;
done;

(*2 (C1 and C2) components inside a third one (C) are either one inside the other or inside 2 different subcp (D1 and D2) of the third*)
(* SubComponentInclusionRule *)
lemma SubComponentInclusionRule: "\<lbrakk>C1\<in>cpSet C; C2\<in>cpSet C; C\<noteq>C1;C\<noteq>C2;C1\<noteq>C2\<rbrakk> \<Longrightarrow> 
  C1\<in>cpSet C2\<or>C2\<in>cpSet C1\<or>
  (  \<exists> C'\<in>cpSet C. \<exists> N itfs cpList bindings s. 
                (C'=(Composite N  itfs cpList bindings s) \<and> (\<exists> D1\<in> set cpList. \<exists>D2\<in>set cpList. 
                      C1\<in>cpSet D1\<and>C2\<in>cpSet D2 \<and>D1\<noteq>D2)))"
apply (insert SubComponentInclusionRule_pre);
by auto;
(*pre*)


lemma disjointRqIds_pre: 
"(\<forall> C1 C2 . (C1\<in>cpSet C\<and>C2\<in>cpSet C\<and> CorrectComponentWeak C\<and>
         C1\<noteq>C2) \<longrightarrow> (list_inter (RqIdLocalList C1) (RqIdLocalList C2) =[]))"
apply (rule induct_Comp);
apply (simp)+;
apply clarify;
apply (erule disjE);
apply (erule disjE);
apply simp+;
apply (erule bexE);
apply (simp only: in_set_conv_nth);
apply (subgoal_tac "C'\<in> set cplist");
prefer 2;apply force;
apply (erule exE)+;
apply (frule_tac i=i in RqIdListofSubcomponentAndParent_disjoint);
apply clarify;
apply simp+;
apply auto;
(*3*)
apply (subgoal_tac "set (RqIdLocalList C2)\<subseteq>set (RqIdList (cplist!i))")
apply (subgoal_tac "distinct ((map fid (CcomputedResults s) @ map Request.id (Cqueue s)) @(RqIdLocalList C2)) ")
apply (drule list_inter_distinctimp);
apply simp+;
apply (subgoal_tac "CorrectComponentWeak (cplist ! i)");
apply (unfold CorrectComponentWeak_def,simp,fold CorrectComponentWeak_def);
apply (drule CorrectComponentListComp);apply (drule_tac x="(cplist ! i)" in CorrectComponentListComp_rev)
apply simp+;
apply force;
apply (drule list_inter_distinctrev);
apply force;
apply auto;
(*9*)
apply (force simp:  CorrectComponentWeak_def);
apply (force simp:  CorrectComponentWeak_def);
apply (rule CorrectComponentWeak_distinctLocalRqIds);
apply (rule SubComponent_CorrectComponentWeak)
apply simp+;
apply (drule CorrectComponentListComp,drule_tac x="(cplist ! i)" in CorrectComponentListComp_rev)
apply simp+;
apply (subgoal_tac "(a,b)\<in>set (RqIdList (cplist ! i))");
apply (simp add: list_inter_disjoint);
apply force;apply force;
apply (unfold CorrectComponentWeak_def,force,fold CorrectComponentWeak_def);
apply (simp add: list_inter_disjoint);
apply force;
apply (drule SubComponent_SmallerRqIdList);
apply (subgoal_tac "set (RqIdLocalList C2)\<subseteq>set (RqIdList C2)");
apply force;
apply (simp add: LocalRqIdList);
apply (simp only: in_set_conv_nth);
apply (subgoal_tac "C'\<in> set cplist");
prefer 2;apply force;
apply (erule exE)+;
apply (frule_tac i=i in RqIdListofSubcomponentAndParent_disjoint);
apply clarify;
apply simp+;
apply auto;
(*2*)
apply (subgoal_tac "set (RqIdLocalList C1)\<subseteq>set (RqIdList (cplist!i))")
apply (subgoal_tac "distinct ((RqIdLocalList C1)@(map fid (CcomputedResults s) @ map Request.id (Cqueue s))) ")
apply (drule list_inter_distinctimp);
apply simp+;
apply (subgoal_tac "CorrectComponentWeak (cplist ! i)");
apply (unfold CorrectComponentWeak_def,simp,fold CorrectComponentWeak_def);
apply (drule CorrectComponentListComp);
apply (drule_tac x="(cplist ! i)" in CorrectComponentListComp_rev)
apply simp;apply simp;apply simp;
apply (drule list_inter_distinctrev);
apply force;
apply auto;
(*8*)
apply (subgoal_tac "CorrectComponentWeak C1");
apply (rule CorrectComponentWeak_distinctLocalRqIds);
apply simp+;
apply (rule SubComponent_CorrectComponentWeak)
apply simp+;
apply (drule CorrectComponentListComp); apply (drule_tac x="(cplist ! i)" in CorrectComponentListComp_rev)
apply simp+;
apply (force simp: CorrectComponentWeak_def);
apply (force simp: CorrectComponentWeak_def);
apply (force simp: CorrectComponentWeak_def);
apply (subgoal_tac "(a,b)\<in>set (RqIdList (cplist ! i))");
apply (simp add: list_inter_disjoint);
apply force;
apply force;
apply (subgoal_tac "(a,b)\<in>set (RqIdList (cplist ! i))");
apply (simp add: list_inter_disjoint);
apply force;
apply force;
apply (drule SubComponent_SmallerRqIdList);
apply (subgoal_tac "set (RqIdLocalList C1)\<subseteq>set (RqIdList C1)");
apply force;
apply (simp add: LocalRqIdList);
(*1*)
apply (case_tac "C'=C'a");
apply (drule_tac x=C' in bspec);
apply simp+;
apply (drule_tac x=C1 in spec);
apply (drule_tac x=C2 in spec);
apply simp+;
apply (drule CorrectComponentListComp);apply (drule_tac x=C'a in CorrectComponentListComp_rev)
apply simp+;
(*1*)
apply (subgoal_tac "list_inter (RqIdList C') (RqIdList C'a) = []")
defer;
apply ((simp add: in_set_conv_nth)+, (erule exE)+);
apply clarify;
apply (rule RqIdListofTwoComponents_disjoint);
apply simp+;
apply force;
apply simp+;
(*1*)
apply (subgoal_tac "set (RqIdLocalList C1)\<subseteq>set (RqIdList C')");
apply (subgoal_tac "set (RqIdLocalList C2)\<subseteq>set (RqIdList C'a)");
apply (simp add: list_inter_disjoint)+;
apply (force simp: Int_def);
apply (drule SubComponent_SmallerRqIdList)+;
apply (subgoal_tac "set (RqIdLocalList C2)\<subseteq>set (RqIdList C2)");
apply force;
apply (simp add: LocalRqIdList);
apply (drule SubComponent_SmallerRqIdList);
apply (subgoal_tac "set (RqIdLocalList C1)\<subseteq>set (RqIdList C1)");
apply force;
apply (simp add: LocalRqIdList);
done;

lemma disjointRqIds: 
"\<lbrakk>Ca\<in>cpSet C;Cb\<in>cpSet C; CorrectComponentWeak C;Ca\<noteq>Cb\<rbrakk> 
\<Longrightarrow> list_inter (RqIdLocalList Ca) (RqIdLocalList Cb) =[]"
apply (insert disjointRqIds_pre, auto);
done;

lemma UniqueLocalResult: 
"\<lbrakk>C'\<in>cpSet C; CorrectComponentWeak C; n<length  (getComputedResults C');
          n'<length  (getComputedResults C');
        fid (getComputedResults C' ! n) =  fid (getComputedResults C' ! n')\<rbrakk> \<Longrightarrow>n=n'"
apply (drule SubComponent_CorrectComponentWeak)
apply simp;
apply (drule  CorrectComponentWeak_distinctLocalRqIds)+;
apply (case_tac C');
apply (auto);
apply (auto simp: List.distinct_conv_nth in_set_conv_nth);
done;


lemma UniqueFindResult: "\<lbrakk>CorrectComponent C;
                 C1\<in>cpSet C;C2\<in>cpSet C;
                 (findInResultList (getComputedResults C1) f)=Some v;
                 (findInResultList (getComputedResults C2) f)=Some v'\<rbrakk>
                                \<Longrightarrow>v=v'\<and>C1=C2"
apply (subgoal_tac " \<exists> i. i < length (cpList C) \<and> cpList C ! i = C1")
apply (subgoal_tac " \<exists> i . i < length (cpList C) \<and> cpList C ! i = C2")
apply ((erule exE)+);
apply clarify;
apply (drule findInResultD)+;
apply (erule exE)+;
apply (frule RequestOfSubComponent_inComputedResultList_unique)
apply force;apply force;
apply (rotate_tac 4)
apply (frule_tac RequestOfSubComponent_inComputedResultList_unique)
apply force;apply force;
apply (erule ex1E)+;
apply (frule CorrectCompWeak)
apply (unfold CorrectComponent_def);
apply (simp only: List.distinct_conv_nth)
(*3*)
apply simp;
apply clarify;
apply (rotate_tac -1)
apply (subgoal_tac "i=ia");
apply (subgoal_tac "n=na");
apply (rotate_tac -1)
apply (thin_tac "\<forall>i<length (cpList C).
           \<forall>j<length (cpList C). i \<noteq> j \<longrightarrow> getName (cpList C ! i) \<noteq> getName (cpList C ! j)");
apply (thin_tac "\<forall>y. y < length (RqIdList C) \<and> RqIdList C ! ma = RqIdList C ! y \<longrightarrow> y = ma");
apply (thin_tac"\<forall>i<length (RqIdList C). \<forall>j<length (RqIdList C). i \<noteq> j \<longrightarrow> RqIdList C ! i \<noteq> RqIdList C ! j");
apply fastsimp;
apply (drule_tac n=n and n'=na in  UniqueLocalResult);
apply assumption+;
apply fastsimp;
(*5*)
apply (rotate_tac -1)
apply (thin_tac "i < length (cpList C)",thin_tac "ia < length (cpList C)" );
apply simp;
apply assumption;
defer;
apply (simp add: cpSetAndList);
apply (simp add: cpSetAndList);
apply (thin_tac "\<forall>i<length (cpList C).
           \<forall>j<length (cpList C). i \<noteq> j \<longrightarrow> getName (cpList C ! i) \<noteq> getName (cpList C ! j)");
apply (subgoal_tac "cpList C ! i=cpList C ! ia")
apply (subgoal_tac "cpList C ! i=cpList C ! ia\<longrightarrow>i=ia")
apply fastsimp;
apply (thin_tac "\<forall>y. y < length (RqIdList C) \<and> RqIdList C ! ma = RqIdList C ! y \<longrightarrow>
            y = m")
apply (thin_tac "\<forall>y. y < length (RqIdList C) \<and> RqIdList C ! ma = RqIdList C ! y \<longrightarrow>
            y = ma")
apply (thin_tac "n < length (getComputedResults (cpList C ! i))")
apply (thin_tac " RqIdList C ! m = RqIdList C ! ma")
apply (thin_tac "\<forall>i<length (RqIdList C).
           \<forall>j<length (RqIdList C). i \<noteq> j \<longrightarrow> RqIdList C ! i \<noteq> RqIdList C ! j")
apply simp;
(*2*)
apply (unfold CorrectComponentWeak_def)
apply (simp add: List.distinct_conv_nth);
apply clarify;
apply (rotate_tac -1);
apply (drule_tac x=i in spec);
apply simp;
apply (rotate_tac -1);
apply (drule_tac x=ia in spec);
apply simp;
(*1*)
apply (subgoal_tac "fid (getComputedResults (cpList C ! ia) ! na) =fid (getComputedResults (cpList C ! i) ! n)");
apply (rotate_tac -1);
apply (erule contrapos_pp)
apply (drule_tac C=C and Ca="cpList C ! i" and  Cb="cpList C ! ia" in disjointRqIds);
apply assumption;
apply (unfold CorrectComponentWeak_def)
apply simp;
apply assumption;
apply (thin_tac "\<forall>y. y < length (RqIdList C) \<and> RqIdList C ! ma = RqIdList C ! y \<longrightarrow>
            y = ma")
apply (thin_tac " RqIdList C ! m = RqIdList C ! ma")
apply (thin_tac "\<forall>i<length (RqIdList C).
           \<forall>j<length (RqIdList C). i \<noteq> j \<longrightarrow> RqIdList C ! i \<noteq> RqIdList C ! j")
apply (simp only: list_inter_disjoint);
(*2*)
apply (subgoal_tac " \<forall> i<length (cpList C). \<forall> n<length (getComputedResults (cpList C ! i)). \<exists> j<length (RqIdLocalList (cpList C ! i)). fid (getComputedResults (cpList C ! i) ! n) =(RqIdLocalList (cpList C ! i))!j" )
apply (rotate_tac -1);
apply (frule_tac x= i in spec);
apply (erule impE,simp);
apply (rotate_tac -1);
apply (drule_tac x= n in spec);
apply (drule_tac x= ia in spec);
apply simp;
apply (rotate_tac -1);
apply (drule_tac x= na in spec);
apply simp+;
apply (erule exE)+;
apply (simp add: in_set_conv_nth);
apply (thin_tac "\<forall>y. y < length (RqIdList C) \<and>
            RqIdLocalList (cpList C ! i) ! j = RqIdList C ! y \<longrightarrow>
            y = m");
apply (subgoal_tac "RqIdLocalList (cpList C ! i) ! j\<in>set (RqIdLocalList (cpList C ! i))");
apply (subgoal_tac "RqIdLocalList (cpList C ! i) ! j\<in> set (RqIdLocalList (cpList C ! ia)) ")
apply force;
(*4*)
apply (simp add: in_set_conv_nth);
apply force;
apply (simp add: in_set_conv_nth);
apply force;
apply clarify;
apply (case_tac "(cpList C ! ib)");
apply simp;
apply (rule_tac x=nb in exI);
apply (simp add: nth_append);
apply (rule_tac x=nb in exI);
apply (simp add: nth_append);
apply simp;
done;

lemma UpdateFuture_maintainsFid: "i<length RL \<Longrightarrow>id ((map (\<lambda>R. R\<lparr>parameter:=UpdateFuture f v (parameter R)\<rparr>) RL)!i) = id (RL!i)" 
apply auto;
done;

primrec LocalReferencedRqs::  "Component \<Rightarrow> Fid set" where
  "LocalReferencedRqs (Primitive N itfs s) = (foldl (\<lambda>x y. x\<union> set (snd(fValue y)))
                                      (foldl (\<lambda>x y. x\<union> set (snd(parameter y))) (set (PRqRefs  (PintState s))) (Pqueue s)) (PcomputedResults s))" |
  "LocalReferencedRqs (Composite N itfs subCp bindings s) = (foldl (\<lambda>x y. x\<union> set (snd (fValue y)))
                                   (foldl (\<lambda>x y. x\<union> set (snd (parameter y))) {} (Cqueue s)) (CcomputedResults s)) " 

(* LocalReferencedRqs returens the set of request Ids referenced in ONE components*)


declare cpSetcomposite[simp]
declare cpSetcomposite_set[simp del]


end